/**
 * @fileoverview iframeϴ
 * @author: ƽӣ<minghe36@126.com>,Ӣ<daxingplay@gmail.com>
 **/
KISSY.add(function(S,Node,UploadType) {
    var EMPTY = '',$ = Node.all,LOG_PREFIX = '[uploader-iframeType]:',ID_PREFIX = 'ks-uploader-iframe-';
    /**
     * @name IframeType
     * @class iframeϴ
     * @constructor
     * @extends Base
     * @requires Node
     */
    function IframeType(config){
        var self = this;
        //ø๹캯
        IframeType.superclass.constructor.call(self,config);
    }
    S.mix(IframeType,/**@lends IframeType*/ {
            /**
             * õhtmlģ
             */
            tpl : {
                IFRAME : '<iframe src="javascript:false;" name="{id}" id="{id}" border="no" width="1" height="1" style="display: none;" />',
                FORM : '<form method="post" enctype="multipart/form-data" action="{action}" target="{target}">{hiddenInputs}</form>',
                HIDDEN_INPUT : '<input type="hidden" name="{name}" value="{value}" />'
            },
            /**
             * ¼б
             */
            event : {
                //ʼϴ󴥷
                START : 'start',
                //ֹͣϴ󴥷
                STOP : 'stop',
                //iframeɺ󴥷
                COMPLETE : 'complete',
                //ϴʧܺ󴥷
                ERROR : 'error',
                //iframeform󴥷
                CREATE : 'create',
                //ɾform󴥷
                REMOVE : 'remove'
            }
    });
    //̳BasegettersetterίBase
    S.extend(IframeType, UploadType, /** @lends IframeType.prototype*/{
            /**
             * ϴļ
             * @param {HTMLElement} fileInput ļinput
             */
            upload : function(fileInput){
                var self = this,$input = $(fileInput),form;
                if(!$input.length) return false;
                self.fire(IframeType.event.START,{input : $input});
                self.set('fileInput',$input);
                //iframeform
                self._create();
                form = self.get('form');
                //ύiframe
                form.getDOMNode().submit();
            },
            /**
             * ֹͣϴ
             * @return {IframeType}
             */
            stop : function(){
                var self = this,iframe = self.get('iframe');
                iframe.attr('src','javascript:"<html></html>";');
                self.fire(IframeType.event.STOP,{iframe : iframe});
                return self;
            },
            /**
             * תhiddenԪ
             * @param {Object} data 
             * @return {String} hiddenInputHtml hiddenԪhtmlƬ
             */
            dataToHidden : function(data){
                if(!S.isObject(data) || S.isEmptyObject(data)){
                    S.log(LOG_PREFIX + 'dataǶΪգ');
                    return false;
                }
                var self = this,hiddenInputHtml = EMPTY,
                    //hiddenԪģ
                    tpl = self.get('tpl'),hiddenTpl = tpl.HIDDEN_INPUT;
                if (!S.isString(hiddenTpl)) return false;
                for (var k in data) {
                    hiddenInputHtml += S.substitute(hiddenTpl, {'name' : k,'value' : data[k]});
                }
                return hiddenInputHtml;
            },
            /**
             * һյiframeļϴύ󷵻ط
             * @return {NodeList}
             */
            _createIframe : function(){
                var self = this,
                    //iframeid
                    id = self.get('id'),
                    //iframeģ
                    tpl = self.get('tpl'),iframeTpl = tpl.IFRAME,
                    existIframe = self.get('iframe'),
                    iframe,$iframe;
                //жǷѾiframeֱӷiframe
                if(!S.isEmptyObject(existIframe)) return existIframe;
                if (!S.isString(iframeTpl)){
                    S.log(LOG_PREFIX + 'iframeģ岻Ϸ');
                    return false;
                }
                if (!S.isString(id)){
                    S.log(LOG_PREFIX + 'idΪַͣ');
                    return false;
                }
                //ϴiframe
                iframe = S.substitute(tpl.IFRAME, { 'id' : id });
                $iframe = $(iframe);
                //iframeload¼
                $iframe.on('load',self._iframeLoadHandler,self);
                $('body').append($iframe);
                self.set('iframe',$iframe);
                return $iframe;
            },
            /**
             * iframeɺ󴥷ļϴ
             */
            _iframeLoadHandler : function(ev){
                var self = this,iframe = ev.target,
                    errorEvent = IframeType.event.ERROR,
                    doc = iframe.contentDocument || window.frames[iframe.id].document,
                    result;
                if(!doc || !doc.body) {
                    self.fire(errorEvent,{msg : '˷⣡'});
                    return false;
                }
                result = doc.body.innerHTML;
                //jsonֱ˳
                if(result == EMPTY) return false;
                try{
                    result = JSON.parse(result);
                }catch(err){
                    S.log(LOG_PREFIX + 'jsonݸʽϷ');
                    self.fire(errorEvent,{msg : 'ݣ'+result+'ǺϷjson'});
                }
                self.fire(IframeType.event.COMPLETE,{result : result});
                self._remove();
            },
            /**
             * ļϴ
             * @return {NodeList}
             */
            _createForm : function(){
                var self = this,
                    //iframeid
                    id = self.get('id'),
                    //formģ
                    tpl = self.get('tpl'),formTpl = tpl.FORM,
                    //Ҫ͸˵
                    data = self.get('data'),
                    //˴ļϴ·
                    action = self.get('action'),
                    fileInput = self.get('fileInput'),
                    hiddens,form = EMPTY,$form;
                if (!S.isString(formTpl)){
                    S.log(LOG_PREFIX + 'formģ岻Ϸ');
                    return false;
                }
                if (!S.isObject(data)){
                    S.log(LOG_PREFIX + 'dataϷ');
                    return false;
                }
                if (!S.isString(action)){
                    S.log(LOG_PREFIX + 'actionϷ');
                    return false;
                }
                hiddens = self.dataToHidden(data);
                if(hiddens == EMPTY) return false;
                form = S.substitute(formTpl, {'action' : action,'target' : id,'hiddenInputs' : hiddens});
                //¡ļ򣬲ӵform
                $form = $(form).append(fileInput.clone());
                $('body').append($form);
                self.set('form',$form);
                return $form;
            },
            /**
             * iframeform
             */
            _create : function(){
                var self = this,
                    iframe = self._createIframe(),
                    form = self._createForm();
                self.fire(IframeType.event.CREATE,{iframe : iframe,form : form});
            },
            /**
             * Ƴ
             */
            _remove : function(){
                var self = this,form = self.get('form'),iframe = self.get('iframe');
                //Ƴ
                form.remove();
                //form
                self.reset('form');
                self.fire(IframeType.event.REMOVE,{form : form});
            }
    },{ATTRS : /** @lends IframeType*/{
            /**
             * iframeõhtmlģ壬һ㲻Ҫ޸
             */
            tpl : {value : IframeType.tpl},
            /**
             * iframeid
             */
            id : {value : ID_PREFIX + S.guid()},
            iframe : {value : {}},
            form : {value : {}},
            fileInput : {value : EMPTY}
    }});
    
    return IframeType;
},{requires:['node','./base']});